diff --git a/src/xenxs/xen_sxpr.h b/src/xenxs/xen_sxpr.h
new file mode 100644
index 0000000..c0c6a53
--- /dev/null
+++ b/src/xenxs/xen_sxpr.h
@@ -0,0 +1,62 @@
+/*
+ * xen_sxpr.h: Xen SEXPR parsing functions
+ *
+ * Copyright (C) 2011 Univention GmbH
+ * Copyright (C) 2006-2008, 2010 Red Hat, Inc.
+ * Copyright (C) 2005,2006
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
+ *
+ * Author: Anthony Liguori <aliguori@us.ibm.com>
+ * Author: Daniel Veillard <veillard@redhat.com>
+ * Author: Markus Groß <gross@univention.de>
+ */
+
+#ifndef __VIR_XEN_SXPR_H__
+# define __VIR_XEN_SXPR_H__
+
+# include "internal.h"
+# include "conf.h"
+# include "domain_conf.h"
+# include "sexpr.h"
+
+# ifdef __sun
+#  define DEFAULT_VIF_SCRIPT "vif-vnic"
+# else
+#  define DEFAULT_VIF_SCRIPT "vif-bridge"
+# endif
+
+/* helper functions to get the dom id from a sexpr */
+int xenGetDomIdFromSxprString(const char *sexpr, int xendConfigVersion);
+int xenGetDomIdFromSxpr(const struct sexpr *root, int xendConfigVersion);
+
+virDomainDefPtr
+xenDaemonParseSxprString(const char *sexpr,
+                         int xendConfigVersion, char *tty, int vncport);
+
+virDomainDefPtr
+xenDaemonParseSxpr(const struct sexpr *root,
+                   int xendConfigVersion,
+                   const char *cpus, char *tty, int vncport);
+
+int
+xenDaemonParseSxprSound(virDomainDefPtr def,
+                        const char *str);
+
+virDomainChrDefPtr
+xenDaemonParseSxprChar(const char *value,
+                       const char *tty);
+
+#endif /* __VIR_XEN_SXPR_H__ */
diff --git a/src/xenxs/xenxs_private.h b/src/xenxs/xenxs_private.h
new file mode 100644
index 0000000..02fd1a3
--- /dev/null
+++ b/src/xenxs/xenxs_private.h
@@ -0,0 +1,37 @@
+/*
+ * xenxs_private.h: Private definitions for Xen parsing
+ *
+ * Copyright (C) 2011 Univention GmbH
+ * Copyright (C) 2007, 2010 Red Hat, Inc.
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
+ *
+ * Author: Richard W.M. Jones <rjones@redhat.com>
+ * Author: Markus Groß <gross@univention.de>
+ */
+
+#ifndef __VIR_XENXS_PRIVATE_H__
+# define __VIR_XENXS_PRIVATE_H__
+
+# include "internal.h"
+
+
+#define VIR_FROM_THIS VIR_FROM_NONE
+
+#define XENXS_ERROR(code, ...)                                                \
+    virReportErrorHelper(NULL, VIR_FROM_NONE, code, __FILE__, __FUNCTION__,   \
+                         __LINE__, __VA_ARGS__)
+
+#endif /* __VIR_XENXS_PRIVATE_H__ */
diff --git a/tests/sexpr2xmltest.c b/tests/sexpr2xmltest.c
index f100dd8..cf3e5bc 100644
--- a/tests/sexpr2xmltest.c
+++ b/tests/sexpr2xmltest.c
@@ -9,6 +9,7 @@
 #include "datatypes.h"
 #include "xen/xen_driver.h"
 #include "xen/xend_internal.h"
+#include "xenxs/xen_sxpr.h"
 #include "testutils.h"
 #include "testutilsxen.h"
 
@@ -25,6 +26,9 @@ static int testCompareFiles(const char *xml, const char *sexpr,
   char *gotxml = NULL;
   char *xmlPtr = &(xmlData[0]);
   char *sexprPtr = &(sexprData[0]);
+  int id;
+  char * tty;
+  int vncport;
   int ret = -1;
   virDomainDefPtr def = NULL;
   virConnectPtr conn;
@@ -48,7 +52,14 @@ static int testCompareFiles(const char *xml, const char *sexpr,
   if (virMutexInit(&priv.lock) < 0)
       goto fail;
 
-  if (!(def = xenDaemonParseSxprString(conn, sexprData, xendConfigVersion)))
+  id = xenGetDomIdFromSxprString(sexprData, xendConfigVersion);
+  xenUnifiedLock(&priv);
+  tty = xenStoreDomainGetConsolePath(conn, id);
+  vncport = xenStoreDomainGetVNCPort(conn, id);
+  xenUnifiedUnlock(&priv);
+
+  if (!(def = xenDaemonParseSxprString(sexprData, xendConfigVersion, tty,
+                                       vncport)))
       goto fail;
 
   if (!(gotxml = virDomainDefFormat(def, 0)))
